//----------------------------------------------------------------------------
//		Temporal Smoother Filter 3DNow! Version 0.90 for AviUtl ver0.98bȍ~
//		AMD 3DNow! Only Version
//		Last Update 2002/07/06
//		Transrated and Optimized By 2ch AviUtl Xbh's member
//		for Borland C++ Builder 6.0Pro
//----------------------------------------------------------------------------
#include <windows.h>
#include <math.h>
#include <float.h>
#include <mem.h>

#include "filter.h"

//#define OPTEST	1					// \eXgp

//////////////////////////////////////////////////////////////////////////////

#define _3DNOW_SUPPORTED	0x80000000
#define _3DNOWENH_SUPPORTED	0x40000000
#define MAX_RADIUS 7				// őQƔ͈
#define MAX_FRAME			(MAX_RADIUS*2+1)

//---------------------------------------------------------------------
//		vg^Cv錾
//---------------------------------------------------------------------
static void __stdcall TSmooth_3DNow_Range0( FILTER *fp,FILTER_PROC_INFO *fpip );
static void __stdcall TSmooth_3DNow_Range1( FILTER *fp,FILTER_PROC_INFO *fpip );
static void __stdcall TSmooth_3DNow_Range2( FILTER *fp,FILTER_PROC_INFO *fpip );
static void __stdcall TSmooth_3DNow_Range3( FILTER *fp,FILTER_PROC_INFO *fpip );
static void __stdcall TSmooth_3DNow_Range4( FILTER *fp,FILTER_PROC_INFO *fpip );
static void __stdcall TSmooth_3DNow_Range5( FILTER *fp,FILTER_PROC_INFO *fpip );
static void __stdcall TSmooth_3DNow_Range6( FILTER *fp,FILTER_PROC_INFO *fpip );
static void __stdcall TSmooth_3DNow_Range7( FILTER *fp,FILTER_PROC_INFO *fpip );

//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
static TCHAR *track_name[] = { "x",	"͈"		};
static int track_default[] = {	6,		3			};
static int track_s[] =		 {	0,		1			};
static int track_e[] =		 { 31,		MAX_RADIUS	};

static FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,
	0, 0,
	"Temporal Smoother 3DNow!",
	sizeof(track_name) / sizeof(*track_name),
	track_name,
	track_default,
	track_s, track_e,
	0,
	NULL,
	NULL,
	func_proc,
	func_init,
	func_exit,
	NULL,
	NULL,
	NULL,NULL,
	NULL,
	NULL,
	"Temporal Smoother  3DNow! for AviUtl",
	NULL,
	NULL,
};

//---------------------------------------------------------------------
//		ϐE\̒`
//---------------------------------------------------------------------
static unsigned int *squaretab;

typedef union QWORD{					// MMX&3DNow!WX^p\
	char  SB[8];
	short SW[4];
	long  SD[2];
	BYTE  UB[8];
	WORD  UW[4];
	DWORD UD[2];
	float f[2];
} TQWORD;

typedef struct LOPINF{
	PIXEL_YC *filt[16];	// +00,+04,+08,+12,+16,+20,+24,+28
						// +32,+36,+40,+44,+48,+52,+56,+60
	DWORD y;			// +64
	DWORD w;			// +68
	DWORD h;			// +72
	DWORD m;			// +76
	PIXEL_YC *p;		// +80
}TLOPINF;

static TQWORD W_MASK1;					// PANDpMASK1(0x0000FFFFFFFFFFFF)
static TQWORD W_MASK2;					// PADDpMASK2(0x00000000FFFFFFFF)
static TQWORD SRL_strength;				// PSRLpSHIFTl(x)
static TQWORD SV_256;					// PSUBUSWp
static TQWORD DV_TBL_3DNOW[256*MAX_FRAME+1];// Divide Value Table for 3DNow!

static TLOPINF lopinf;					// AZupϐW\

unsigned int flag_Support_3DNow;

void __stdcall (*TSmooth[8])( FILTER *fp,FILTER_PROC_INFO *fpip )={
	TSmooth_3DNow_Range0,	// Range=0(Dummy)
	TSmooth_3DNow_Range1,	// Range=1
	TSmooth_3DNow_Range2,	// Range=2
	TSmooth_3DNow_Range3,	// Range=3
	TSmooth_3DNow_Range4,	// Range=4
	TSmooth_3DNow_Range5,	// Range=5
	TSmooth_3DNow_Range6,	// Range=6
	TSmooth_3DNow_Range7,	// Range=7
};

#ifdef	OPTEST
static DWORD  StartTimeH,StartTimeL;
static DWORD  EndTimeH,EndTimeL;
#include "LEDFONT.H"
//---------------------------------------------------------------------
static void __stdcall tmStart(void)
{
	_asm{
		push	edx
		push	eax
		rdtsc
		mov 	StartTimeH,edx
		mov 	StartTimeL,eax
		pop		eax
		pop		edx
	};
	return ;
}
//---------------------------------------------------------------------
static void __stdcall DispChar(FILTER_PROC_INFO *fpip, int dspx, int dspy, int c)
{
	int p=c*64;
	PIXEL_YC *wrt1;
	for(int y=dspy;y<dspy+8;y++){
		wrt1=fpip->ycp_edit+y*fpip->max_w+dspx;
		for(int x=0;x<8;x++){
			wrt1->y  = LEDFontGrif[p++]*4095;
			wrt1->cb = 0;
			wrt1->cr = 0;
			wrt1++;
		}
	}
}
//---------------------------------------------------------------------
static void __stdcall tmStop(void)
{
	_asm{
		push	edx
		push	eax
		rdtsc
		sub		eax, StartTimeL
		sbb		edx, StartTimeH
		mov 	EndTimeH,edx
		mov 	EndTimeL,eax
		pop		eax
		pop		edx
	};
	return ;
}
//---------------------------------------------------------------------
static void __stdcall tmDisp(FILTER *fp, FILTER_PROC_INFO *fpip, int y)
{
	int x=0;
	DWORD dTmp;
	for(int i=0;i<8;i++){
		dTmp = (EndTimeH>>(28-i*4))&0xF;
		DispChar(fpip, x, y, dTmp);
		x+=8;
	}
	for(int i=0;i<8;i++){
		dTmp = (EndTimeL>>(28-i*4))&0xF;
		DispChar(fpip, x, y, dTmp);
		x+=8;
	}
	return ;
}
#endif											// for OPTEST
//---------------------------------------------------------------------
//		Temporal Smoother for 3DNow! Range=0 Full Assember Version
//		for Performance Test
//---------------------------------------------------------------------
static void __stdcall TSmooth_3DNow_Range0( FILTER *fp,FILTER_PROC_INFO *fpip )
{
#ifdef OPTEST
	tmStart();
#endif
	// ݒlς̂݃LbV̈Ċm
	// kernel̓t[
	fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 7, NULL);

	// flit|C^zɑOt[̃|C^GET
	for(int i = 0; i < 7; i++) {
		lopinf.filt[i] = (PIXEL_YC *)fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, fpip->frame - 3 + i);
	}
	// AZupWϐ\̏
	lopinf.m = (fpip->max_w - fpip->w)*6;
	lopinf.w = fpip->w;
	lopinf.h = fpip->h;
	lopinf.p = fpip->ycp_edit;

#ifdef OPTEST
	tmStop();
	tmDisp(fp, fpip, 0);
#endif
	return;
}
//---------------------------------------------------------------------
//		Temporal Smoother for 3DNow! Range=1 Full Assember Version
//---------------------------------------------------------------------
static void __stdcall TSmooth_3DNow_Range1( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	// ݒlς̂݃LbV̈Ċm
	// kernel̓t[
	fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 3, NULL);

	// flit|C^zɑOt[̃|C^GET
	for(int i = 0; i < 3; i++) {
		lopinf.filt[i] = (PIXEL_YC *)fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, fpip->frame - 1 + i);
	}
	// AZupWϐ\̏
	lopinf.m = (fpip->max_w - fpip->w)*6;
	lopinf.w = fpip->w;
	lopinf.h = fpip->h;
	lopinf.p = fpip->ycp_edit;

#ifdef OPTEST
	tmStart();
#endif
	_asm{
		push	ebp
		push	edi
		push	esi
		push	ebx
		mov		ebp, offset lopinf	// EBP <- Gathering variable structure

		prefetchnta	[ebp]
		mov		eax, [ebp+72]
		mov		[ebp+64], eax		// Init. y
		mov		esi, [ebp+04]		// ESI <- Center Frame Pointer

        nop
        nop
        nop
yloop_r1:
		mov		edi, [ebp+00]		// -1 Flame
		mov		ebx, [ebp+08]		// +1 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		prefetchnta	[esi]
		mov		ecx, [ebp+68]		// Init. x
		xor		edx, edx
		pxor	mm6, mm6			// (CB ,  Y)
		pxor	mm7, mm7			// (N/A, CR)

        nop
        nop
xloop_r1:
		// Range 1/1
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 0], 6
		add		dword ptr [ebp+ 8], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		add		edx, eax
		pmulhw	mm4, mm3
		add		edx, 256
		mov		eax, [ebp+80]		// p
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0

		// Center Frame
		pxor	mm1, mm1
		movq	mm0, qword ptr [esi]
		paddd	mm7, mm5
		paddd	mm6, mm3
		pcmpgtw	mm1, mm0
		movq	mm2, mm0
		punpcklwd  mm0, mm1
		punpckhwd  mm2, mm1
		pslld	mm0, 8
		pslld	mm2, 8
		paddd	mm6, mm0
		paddd	mm7, mm2

		// Z
		PI2FD	mm6, mm6
		add		esi, 6
		PFMUL	mm6, qword ptr DV_TBL_3DNOW[edx*8]
		PI2FD	mm7, mm7
		add		dword ptr [ebp+80], 6
		PFMUL	mm7, qword ptr DV_TBL_3DNOW[edx*8]
		xor		edx, edx
		mov		ebx, [ebp+08]		// +1 Flame
		PF2ID	mm6, mm6
		prefetchnta	[esi]
		PF2ID	mm7, mm7
		prefetchnta	[ebx]
		packssdw	mm6, mm7
		mov		edi, [ebp+00]		// -1 Flame
		pxor	mm7, mm7			// (N/A, CR)
		prefetchnta	[edi]

		// Write to Buffer
		movntq	qword ptr [eax], mm6
		dec		ecx
		pxor	mm6, mm6			// (CB ,  Y)

		jnz		xloop_r1

		mov		eax, [ebp+76]		// m
		add		[ebp+80], eax		// p+=m

		dec		dword ptr [ebp+64]	// y
		jnz		yloop_r1
		FEMMS						// Fast MMX Finish
		pop		ebx
		pop		esi
		pop		edi
		pop		ebp
	};
#ifdef OPTEST
	tmStop();
	tmDisp(fp, fpip, 0);
#endif
	return;
}
//---------------------------------------------------------------------
//		Temporal Smoother for 3DNow! Range=2 Full Assember Version
//---------------------------------------------------------------------
static void __stdcall TSmooth_3DNow_Range2( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	// ݒlς̂݃LbV̈Ċm
	// kernel̓t[
	fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 5, NULL);

	// flit|C^zɑOt[̃|C^GET
	for(int i = 0; i < 5; i++) {
		lopinf.filt[i] = (PIXEL_YC *)fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, fpip->frame - 2 + i);
	}
	// AZupWϐ\̏
	lopinf.m = (fpip->max_w - fpip->w)*6;
	lopinf.w = fpip->w;
	lopinf.h = fpip->h;
	lopinf.p = fpip->ycp_edit;

#ifdef OPTEST
	tmStart();
#endif
	_asm{
		push	ebp
		push	edi
		push	esi
		push	ebx
		mov		ebp, offset lopinf	// EBP <- Gathering variable structure
		prefetchnta	[ebp]

		mov		eax, [ebp+72]
		mov		[ebp+64], eax		// Init. y
		mov		esi, [ebp+08]		// ESI <- Center Frame Pointer

        nop
yloop_r2:
		mov		edi, [ebp+00]		// -2 Flame
		mov		ebx, [ebp+16]		// +2 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		prefetchnta	[esi]
		mov		ecx, [ebp+68]		// Init. x
		xor		edx, edx
		pxor	mm6, mm6			// (CB ,  Y)
		pxor	mm7, mm7			// (N/A, CR)

        nop
        nop
xloop_r2:
		// Range 1/2
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 0], 6
		add		dword ptr [ebp+16], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+04]		// -1 Flame
		mov		ebx, [ebp+12]		// +1 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 2/2

		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 4], 6
		add		dword ptr [ebp+12], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		add		edx, eax
		pmulhw	mm4, mm3
		add		edx, 256
		mov		eax, [ebp+80]		// p
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0

		// Center Frame
		pxor	mm1, mm1
		movq	mm0, qword ptr [esi]
		paddd	mm7, mm5
		paddd	mm6, mm3
		pcmpgtw	mm1, mm0
		movq	mm2, mm0
		punpcklwd  mm0, mm1
		punpckhwd  mm2, mm1
		pslld	mm0, 8
		pslld	mm2, 8
		paddd	mm6, mm0
		paddd	mm7, mm2

		// Z
		PI2FD	mm6, mm6
		add		esi, 6
		PFMUL	mm6, qword ptr DV_TBL_3DNOW[edx*8]
		PI2FD	mm7, mm7
		add		dword ptr [ebp+80], 6
		PFMUL	mm7, qword ptr DV_TBL_3DNOW[edx*8]
		xor		edx, edx
		mov		ebx, [ebp+16]		// +2 Flame
		PF2ID	mm6, mm6
		prefetchnta	[esi]
		PF2ID	mm7, mm7
		prefetchnta	[ebx]
		packssdw	mm6, mm7
		mov		edi, [ebp+00]		// -2 Flame
		pxor	mm7, mm7			// (N/A, CR)
		prefetchnta	[edi]

		// Write to Buffer
		movntq	qword ptr [eax], mm6
		dec		ecx
		pxor	mm6, mm6			// (CB ,  Y)

		jnz		xloop_r2

		mov		eax, [ebp+76]		// m
		add		[ebp+80], eax		// p+=m

		dec		dword ptr [ebp+64]	// y
		jnz		yloop_r2
		FEMMS						// Fast MMX Finish
		pop		ebx
		pop		esi
		pop		edi
		pop		ebp
	};
#ifdef OPTEST
	tmStop();
	tmDisp(fp, fpip, 0);
#endif
	return;
}
//---------------------------------------------------------------------
//		Temporal Smoother for 3DNow! Range=3 Full Assember Version
//---------------------------------------------------------------------
static void __stdcall TSmooth_3DNow_Range3( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	// ݒlς̂݃LbV̈Ċm
	// kernel̓t[
	fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 7, NULL);

	// flit|C^zɑOt[̃|C^GET
	for(int i = 0; i < 7; i++) {
		lopinf.filt[i] = (PIXEL_YC *)fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, fpip->frame - 3 + i);
	}
	// AZupWϐ\̏
	lopinf.m = (fpip->max_w - fpip->w)*6;
	lopinf.w = fpip->w;
	lopinf.h = fpip->h;
	lopinf.p = fpip->ycp_edit;

#ifdef OPTEST
	tmStart();
#endif
	_asm{
		push	ebp
		push	edi
		push	esi
		push	ebx
		mov		ebp, offset lopinf	// EBP <- Gathering variable structure

		prefetchnta	[ebp]
		mov		eax, [ebp+72]
		mov		[ebp+64], eax		// Init. y
		mov		esi, [ebp+12]		// ESI <- Center Frame Pointer

        nop
yloop_r3:
		mov		edi, [ebp+00]		// -3 Flame
		mov		ebx, [ebp+24]		// +3 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		prefetchnta	[esi]
		mov		ecx, [ebp+68]		// Init. x
		xor		edx, edx
		pxor	mm7, mm7			// (N/A, CR)
		pxor	mm6, mm6			// (CB ,  Y)

        nop
        nop
xloop_r3:
		// Range 1/3
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 0], 6
		add		dword ptr [ebp+24], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+04]		// -2 Flame
		mov		ebx, [ebp+20]		// +2 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 2/3
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 4], 6
		add		dword ptr [ebp+20], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+08]		// -1 Flame
		mov		ebx, [ebp+16]		// +1 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 3/3
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 8], 6
		add		dword ptr [ebp+16], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		add		edx, eax
		pmulhw	mm4, mm3
		add		edx, 256
		mov		eax, [ebp+80]		// p
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0

		// Center Frame
		pxor	mm1, mm1
		movq	mm0, qword ptr [esi]
		paddd	mm7, mm5
		paddd	mm6, mm3
		pcmpgtw	mm1, mm0
		movq	mm2, mm0
		punpcklwd  mm0, mm1
		punpckhwd  mm2, mm1
		pslld	mm0, 8
		pslld	mm2, 8
		paddd	mm6, mm0
		paddd	mm7, mm2

		// Z
		PI2FD	mm6, mm6
		add		esi, 6
		PFMUL	mm6, qword ptr DV_TBL_3DNOW[edx*8]
		PI2FD	mm7, mm7
		add		dword ptr [ebp+80], 6
		PFMUL	mm7, qword ptr DV_TBL_3DNOW[edx*8]
		xor		edx, edx
		mov		ebx, [ebp+24]		// +3 Flame
		PF2ID	mm6, mm6
		prefetchnta	[esi]
		PF2ID	mm7, mm7
		prefetchnta	[ebx]
		packssdw	mm6, mm7
		mov		edi, [ebp+00]		// -3 Flame
		pxor	mm7, mm7			// (N/A, CR)
		prefetchnta	[edi]

		// Write to Buffer
		movntq	qword ptr [eax], mm6
		dec		ecx
		pxor	mm6, mm6			// (CB ,  Y)

		jnz		xloop_r3

		mov		eax, [ebp+76]		// m
		add		[ebp+80], eax		// p+=m

		dec		dword ptr [ebp+64]	// y
		jnz		yloop_r3
		FEMMS						// Fast MMX Finish
		pop		ebx
		pop		esi
		pop		edi
		pop		ebp
	};
#ifdef OPTEST
	tmStop();
	tmDisp(fp, fpip, 0);
#endif
	return;
}
//---------------------------------------------------------------------
//		Temporal Smoother for 3DNow! Range=4 Full Assember Version
//---------------------------------------------------------------------
static void __stdcall TSmooth_3DNow_Range4( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	// ݒlς̂݃LbV̈Ċm
	// kernel̓t[
	fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 9, NULL);

	// flit|C^zɑOt[̃|C^GET
	for(int i = 0; i < 9; i++) {
		lopinf.filt[i] = (PIXEL_YC *)fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, fpip->frame - 4 + i);
	}
	// AZupWϐ\̏
	lopinf.m = (fpip->max_w - fpip->w)*6;
	lopinf.w = fpip->w;
	lopinf.h = fpip->h;
	lopinf.p = fpip->ycp_edit;

#ifdef OPTEST
	tmStart();
#endif
	_asm{
		push	ebp
		push	edi
		push	esi
		push	ebx
		mov		ebp, offset lopinf	// EBP <- Gathering variable structure
		prefetchnta	[ebp]

		mov		eax, [ebp+72]
		mov		[ebp+64], eax		// Init. y
		mov		esi, [ebp+16]		// ESI <- Center Frame Pointer

        nop
yloop_r4:
		mov		edi, [ebp+00]		// -4 Flame
		mov		ebx, [ebp+32]		// +4 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		prefetchnta	[esi]
		mov		ecx, [ebp+68]		// Init. x
		prefetchnta	[esi]
		xor		edx, edx
		pxor	mm6, mm6			// (CB ,  Y)
		pxor	mm7, mm7			// (N/A, CR)

        nop
        nop
        nop
xloop_r4:
		// Range 1/4
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		add		dword ptr [ebp+ 0], 6
		add		dword ptr [ebp+32], 6
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		movq	mm0, mm2
		movq	mm3, mm5
		mov		edi, [ebp+04]		// -3 Flame
		mov		ebx, [ebp+28]		// +3 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 2/4
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 4], 6
		add		dword ptr [ebp+28], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+08]		// -2 Flame
		mov		ebx, [ebp+24]		// +2 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 3/4
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 8], 6
		add		dword ptr [ebp+24], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+12]		// -1 Flame
		mov		ebx, [ebp+20]		// +1 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 4/4
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		add		dword ptr [ebp+12], 6
		add		dword ptr [ebp+20], 6
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		add		edx, eax
		pmulhw	mm4, mm3
		add		edx, 256
		mov		eax, [ebp+80]		// p
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0

		// Center Frame
		pxor	mm1, mm1
		movq	mm0, qword ptr [esi]
		paddd	mm7, mm5
		paddd	mm6, mm3
		pcmpgtw	mm1, mm0
		movq	mm2, mm0
		punpcklwd  mm0, mm1
		punpckhwd  mm2, mm1
		pslld	mm0, 8
		pslld	mm2, 8
		paddd	mm6, mm0
		paddd	mm7, mm2

		// Z
		PI2FD	mm6, mm6
		add		esi, 6
		PFMUL	mm6, qword ptr DV_TBL_3DNOW[edx*8]
		PI2FD	mm7, mm7
		add		dword ptr [ebp+80], 6
		xor		edx, edx
		PFMUL	mm7, qword ptr DV_TBL_3DNOW[edx*8]
		mov		ebx, [ebp+32]		// +4 Flame
		PF2ID	mm6, mm6
		prefetchnta	[esi]
		PF2ID	mm7, mm7
		prefetchnta	[ebx]
		packssdw	mm6, mm7
		mov		edi, [ebp+00]		// -4 Flame
		pxor	mm7, mm7			// (N/A, CR)
		prefetchnta	[edi]

		// Write to Buffer
		movntq	qword ptr [eax], mm6
		dec		ecx
		pxor	mm6, mm6			// (CB ,  Y)

		jnz		xloop_r4

		mov		eax, [ebp+76]		// m
		add		[ebp+80], eax		// p+=m

		dec		dword ptr [ebp+64]	// y
		jnz		yloop_r4
		FEMMS						// Fast MMX Finish
		pop		ebx
		pop		esi
		pop		edi
		pop		ebp
	};
#ifdef OPTEST
	tmStop();
	tmDisp(fp, fpip, 0);
#endif
	return;
}
//---------------------------------------------------------------------
//		Temporal Smoother for 3DNow! Range=5 Full Assember Version
//---------------------------------------------------------------------
static void __stdcall TSmooth_3DNow_Range5( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	// ݒlς̂݃LbV̈Ċm
	// kernel̓t[
	fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 11, NULL);

	// flit|C^zɑOt[̃|C^GET
	for(int i = 0; i < 11; i++) {
		lopinf.filt[i] = (PIXEL_YC *)fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, fpip->frame - 5 + i);
	}
	// AZupWϐ\̏
	lopinf.m = (fpip->max_w - fpip->w)*6;
	lopinf.w = fpip->w;
	lopinf.h = fpip->h;
	lopinf.p = fpip->ycp_edit;

#ifdef OPTEST
	tmStart();
#endif
	_asm{
		push	ebp
		push	edi
		push	esi
		push	ebx
		mov		ebp, offset lopinf	// EBP <- Gathering variable structure
		prefetchnta	[ebp]

		mov		eax, [ebp+72]
		mov		[ebp+64], eax		// Init. y
		mov		esi, [ebp+20]		// ESI <- Center Frame Pointer

        nop
yloop_r5:
		mov		edi, [ebp+00]		// -5Flame
		mov		ebx, [ebp+40]		// +5Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		prefetchnta	[esi]
		mov		ecx, [ebp+68]		// Init. x
		xor		edx, edx
		pxor	mm6, mm6			// (CB ,  Y)
		pxor	mm7, mm7			// (N/A, CR)

        nop
        nop
xloop_r5:
		// Range 1/5
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 0], 6
		add		dword ptr [ebp+40], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+04]		// -4 Flame
		mov		ebx, [ebp+36]		// +4 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 2/5
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 4], 6
		add		dword ptr [ebp+36], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+08]		// -3 Flame
		mov		ebx, [ebp+32]		// +3 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 3/5
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 8], 6
		add		dword ptr [ebp+32], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0

		// Range 4/5
		mov		edi, [ebp+12]		// -2 Flame
		mov		ebx, [ebp+28]		// +2 Flame
		paddd	mm7, mm5
		paddd	mm6, mm3
		prefetchnta	[edi]
		prefetchnta	[ebx]

		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+12], 6
		add		dword ptr [ebp+28], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+16]		// -1 Flame
		mov		ebx, [ebp+24]		// +1 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 5/5
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+16], 6
		add		dword ptr [ebp+24], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		add		edx, eax
		pmulhw	mm4, mm3
		add		edx, 256
		mov		eax, [ebp+80]		// p
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0

		// Center Frame
		pxor	mm1, mm1
		movq	mm0, qword ptr [esi]
		paddd	mm7, mm5
		paddd	mm6, mm3
		pcmpgtw	mm1, mm0
		movq	mm2, mm0
		punpcklwd  mm0, mm1
		punpckhwd  mm2, mm1
		pslld	mm0, 8
		pslld	mm2, 8
		paddd	mm6, mm0
		paddd	mm7, mm2

		// Z
		PI2FD	mm6, mm6
		add		esi, 6
		PFMUL	mm6, qword ptr DV_TBL_3DNOW[edx*8]
		PI2FD	mm7, mm7
		add		dword ptr [ebp+80], 6
		PFMUL	mm7, qword ptr DV_TBL_3DNOW[edx*8]
		xor		edx, edx
		mov		ebx, [ebp+40]		// +5Flame
		PF2ID	mm6, mm6
		prefetchnta	[esi]
		PF2ID	mm7, mm7
		prefetchnta	[ebx]
		packssdw	mm6, mm7
		mov		edi, [ebp+00]		// -5Flame
		pxor	mm7, mm7			// (N/A, CR)
		prefetchnta	[edi]

		// Write to Buffer
		movntq	qword ptr [eax], mm6
		dec		ecx
		pxor	mm6, mm6			// (CB ,  Y)

		jnz		xloop_r5

		mov		eax, [ebp+76]		// m
		add		[ebp+80], eax		// p+=m

		dec		dword ptr [ebp+64]	// y
		jnz		yloop_r5
		FEMMS						// Fast MMX Finish
		pop		ebx
		pop		esi
		pop		edi
		pop		ebp
	};
#ifdef OPTEST
	tmStop();
	tmDisp(fp, fpip, 0);
#endif
	return;
}
//---------------------------------------------------------------------
//		Temporal Smoother for 3DNow! Range=6 Full Assember Version
//---------------------------------------------------------------------
static void __stdcall TSmooth_3DNow_Range6( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	// ݒlς̂݃LbV̈Ċm
	// kernel̓t[
	fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 13, NULL);

	// flit|C^zɑOt[̃|C^GET
	for(int i = 0; i < 13; i++) {
		lopinf.filt[i] = (PIXEL_YC *)fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, fpip->frame - 6 + i);
	}
	// AZupWϐ\̏
	lopinf.m = (fpip->max_w - fpip->w)*6;
	lopinf.w = fpip->w;
	lopinf.h = fpip->h;
	lopinf.p = fpip->ycp_edit;

#ifdef OPTEST
	tmStart();
#endif
	_asm{
		push	ebp
		push	edi
		push	esi
		push	ebx
		mov		ebp, offset lopinf	// EBP <- Gathering variable structure
		prefetchnta	[ebp]

		mov		eax, [ebp+72]
		mov		[ebp+64], eax		// Init. y
		mov		esi, [ebp+24]		// ESI <- Center Frame Pointer

        nop
yloop_r6:
		mov		edi, [ebp+00]		// -6Flame
		mov		ebx, [ebp+48]		// +6Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		prefetchnta	[esi]
		mov		ecx, [ebp+68]		// Init. x
		xor		edx, edx
		pxor	mm6, mm6			// (CB ,  Y)
		pxor	mm7, mm7			// (N/A, CR)

        nop
        nop
xloop_r6:
		// Range 1/6
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 0], 6
		add		dword ptr [ebp+48], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+04]		// -5 Flame
		mov		ebx, [ebp+44]		// +5 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 2/6
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 4], 6
		add		dword ptr [ebp+44], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+08]		// -4 Flame
		mov		ebx, [ebp+40]		// +4 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 3/6
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 8], 6
		add		dword ptr [ebp+40], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+12]		// -3 Flame
		mov		ebx, [ebp+36]		// +3 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 4/6
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+12], 6
		add		dword ptr [ebp+36], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+16]		// -2 Flame
		mov		ebx, [ebp+32]		// +2 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 5/6
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+16], 6
		add		dword ptr [ebp+32], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+20]		// -1 Flame
		mov		ebx, [ebp+28]		// +1 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 6/6
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+20], 6
		add		dword ptr [ebp+28], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		add		edx, eax
		pmulhw	mm4, mm3
		add		edx, 256
		mov		eax, [ebp+80]		// p
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0

		// Center Frame
		pxor	mm1, mm1
		movq	mm0, qword ptr [esi]
		paddd	mm7, mm5
		paddd	mm6, mm3
		pcmpgtw	mm1, mm0
		movq	mm2, mm0
		punpcklwd  mm0, mm1
		punpckhwd  mm2, mm1
		pslld	mm0, 8
		pslld	mm2, 8
		paddd	mm6, mm0
		paddd	mm7, mm2

		// Z
		PI2FD	mm6, mm6
		add		esi, 6
		PFMUL	mm6, qword ptr DV_TBL_3DNOW[edx*8]
		PI2FD	mm7, mm7
		add		dword ptr [ebp+80], 6
		PFMUL	mm7, qword ptr DV_TBL_3DNOW[edx*8]
		xor		edx, edx
		mov		ebx, [ebp+48]		// +6Flame
		PF2ID	mm6, mm6
		prefetchnta	[esi]
		PF2ID	mm7, mm7
		prefetchnta	[ebx]
		packssdw	mm6, mm7
		mov		edi, [ebp+00]		// -6Flame
		pxor	mm7, mm7			// (N/A, CR)
		prefetchnta	[edi]

		// Write to Buffer
		movntq	qword ptr [eax], mm6
		dec		ecx
		pxor	mm6, mm6			// (CB ,  Y)

		jnz		xloop_r6

		mov		eax, [ebp+76]		// m
		add		[ebp+80], eax		// p+=m

		dec		dword ptr [ebp+64]	// y
		jnz		yloop_r6
		FEMMS						// Fast MMX Finish
		pop		ebx
		pop		esi
		pop		edi
		pop		ebp
	};
#ifdef OPTEST
	tmStop();
	tmDisp(fp, fpip, 0);
#endif
	return;
}
//---------------------------------------------------------------------
//		Temporal Smoother for 3DNow! Range=7 Full Assember Version
//---------------------------------------------------------------------
static void __stdcall TSmooth_3DNow_Range7( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	// ݒlς̂݃LbV̈Ċm
	// kernel̓t[
	fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 15, NULL);

	// flit|C^zɑOt[̃|C^GET
	for(int i = 0; i < 15; i++) {
		lopinf.filt[i] = (PIXEL_YC *)fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, fpip->frame - 7 + i);
	}
	// AZupWϐ\̏
	lopinf.m = (fpip->max_w - fpip->w)*6;
	lopinf.w = fpip->w;
	lopinf.h = fpip->h;
	lopinf.p = fpip->ycp_edit;

#ifdef OPTEST
	tmStart();
#endif
	_asm{
		push	ebp
		push	edi
		push	esi
		push	ebx
		mov		ebp, offset lopinf	// EBP <- Gathering variable structure
		prefetchnta	[ebp]

		mov		eax, [ebp+72]
		mov		[ebp+64], eax		// Init. y
		mov		esi, [ebp+28]		// ESI <- Center Frame Pointer

        nop
yloop_r7:
		mov		edi, [ebp+00]		// -7Flame
		mov		ebx, [ebp+56]		// +7Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		prefetchnta	[esi]
		mov		ecx, [ebp+68]		// Init. x
		xor		edx, edx
		pxor	mm6, mm6			// (CB ,  Y)
		pxor	mm7, mm7			// (N/A, CR)

        nop
        nop
xloop_r7:
		// Range 1/7
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 0], 6
		add		dword ptr [ebp+56], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		mov		edi, [ebp+04]		// -6 Flame
		mov		ebx, [ebp+52]		// +6 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		add		edx, eax
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 2/7
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 4], 6
		add		dword ptr [ebp+52], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+08]		// -5 Flame
		mov		ebx, [ebp+48]		// +5 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 3/7
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+ 8], 6
		add		dword ptr [ebp+48], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+12]		// -4 Flame
		mov		ebx, [ebp+44]		// +4 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 4/7
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+12], 6
		add		dword ptr [ebp+44], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+16]		// -3 Flame
		mov		ebx, [ebp+40]		// +3 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 5/7
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+16], 6
		add		dword ptr [ebp+40], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+20]		// -2 Flame
		mov		ebx, [ebp+36]		// +2 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 6/7
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+20], 6
		add		dword ptr [ebp+36], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		pmulhw	mm4, mm3
		add		edx, eax
		mov		edi, [ebp+24]		// -1 Flame
		mov		ebx, [ebp+32]		// +1 Flame
		prefetchnta	[edi]
		prefetchnta	[ebx]
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0
		paddd	mm7, mm5
		paddd	mm6, mm3

		// Range 7/7
		movq	mm0, qword ptr [edi]
		movq	mm3, qword ptr [ebx]
		psubw	mm0, qword ptr [esi]
		psubw	mm3, qword ptr [esi]
		pand	mm0, qword ptr W_MASK1
		pand	mm3, qword ptr W_MASK1
		pmaddwd mm0, mm0
		pmaddwd mm3, mm3
		movq	mm2, qword ptr SV_256
		movq	mm5, qword ptr SV_256
		add		dword ptr [ebp+24], 6
		add		dword ptr [ebp+32], 6
		pshufw	mm1, mm0, 0x0E
		pshufw	mm4, mm3, 0x0E
		paddd	mm0, mm1
		paddd	mm3, mm4
		pand	mm0, qword ptr W_MASK2
		pand	mm3, qword ptr W_MASK2
		psrlq	mm0, qword ptr SRL_strength
		psrlq	mm3, qword ptr SRL_strength
		packssdw	mm0, mm0
		packssdw	mm3, mm3
		psubusw	mm2, mm0
		psubusw	mm5, mm3
		movq	mm1, qword ptr [edi]
		movq	mm4, qword ptr [ebx]
		movd	eax, mm2
		pshufw	mm0, mm2, 0x00
		add		edx, eax
		pshufw	mm3, mm5, 0x00
		movd	eax, mm5
		movq	mm2, mm1
		movq	mm5, mm4
		pmullw	mm2, mm0
		pmullw	mm5, mm3
		pmulhw	mm1, mm0
		add		edx, eax
		pmulhw	mm4, mm3
		add		edx, 256
		mov		eax, [ebp+80]		// p
		movq	mm0, mm2
		movq	mm3, mm5
		punpckhwd	mm2, mm1
		punpckhwd	mm5, mm4
		punpcklwd	mm0, mm1
		punpcklwd	mm3, mm4
		paddd	mm7, mm2
		paddd	mm6, mm0

		// Center Frame
		pxor	mm1, mm1
		movq	mm0, qword ptr [esi]
		paddd	mm7, mm5
		paddd	mm6, mm3
		pcmpgtw	mm1, mm0
		movq	mm2, mm0
		punpcklwd  mm0, mm1
		punpckhwd  mm2, mm1
		pslld	mm0, 8
		pslld	mm2, 8
		paddd	mm6, mm0
		paddd	mm7, mm2

		// Z
		PI2FD	mm6, mm6
		add		esi, 6
		PFMUL	mm6, qword ptr DV_TBL_3DNOW[edx*8]
		PI2FD	mm7, mm7
		add		dword ptr [ebp+80], 6
		PFMUL	mm7, qword ptr DV_TBL_3DNOW[edx*8]
		xor		edx, edx
		mov		ebx, [ebp+56]		// +7Flame
		PF2ID	mm6, mm6
		prefetchnta	[esi]
		PF2ID	mm7, mm7
		prefetchnta	[ebx]
		packssdw	mm6, mm7
		mov		edi, [ebp+00]		// -7Flame
		pxor	mm7, mm7			// (N/A, CR)
		prefetchnta	[edi]

		// Write to Buffer
		movntq	qword ptr [eax], mm6
		dec		ecx
		pxor	mm6, mm6			// (CB ,  Y)

		jnz		xloop_r7

		mov		eax, [ebp+76]		// m
		add		[ebp+80], eax		// p+=m

		dec		dword ptr [ebp+64]	// y
		jnz		yloop_r7
		FEMMS						// Fast MMX Finish
		pop		ebx
		pop		esi
		pop		edi
		pop		ebp
	};
#ifdef OPTEST
	tmStop();
	tmDisp(fp, fpip, 0);
#endif
	return;
}
//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}
//---------------------------------------------------------------------
//		tB^Jn
//---------------------------------------------------------------------
BOOL func_init( FILTER *fp ){

	_asm{
		// CPUID Check
		pushfd

		pop		eax
		xor		eax, 0x00200000

		push	eax
		popfd

		pushfd

		pop		ebx
		cmp		eax, ebx
		jnz		EXIT

		// ŏI`FbN
		cmp		eax, 0x80000000
		jb		EXIT

		mov		eax, 0x80000001
		cpuid
		mov		flag_Support_3DNow, edx

EXIT:
	}
	flag_Support_3DNow &= (_3DNOW_SUPPORTED | _3DNOWENH_SUPPORTED);
	if(!flag_Support_3DNow&_3DNOW_SUPPORTED){
		return FALSE;
	}

	DV_TBL_3DNOW[0].f[0] = DV_TBL_3DNOW[0].f[1] = 1.0;
	for(int i=1; i<=256*MAX_FRAME; i++){
		DV_TBL_3DNOW[i].f[0] = DV_TBL_3DNOW[i].f[1] = 1.0/float(i);
	}
	W_MASK1.UD[0] = 0xFFFFFFFF;
	W_MASK1.UD[1] = 0x0000FFFF;
	W_MASK2.UD[0] = 0xFFFFFFFF;
	W_MASK2.UD[1] = 0x00000000;
	SV_256.UD[0]  = 256;
	SV_256.UD[1]  = 0;
	SRL_strength.UD[1] = 0;

	return TRUE;
}
//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
static BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	if(!fp->exfunc->is_editing(fpip->editp)&&
	   !fp->exfunc->is_saveframe(fpip->editp, fpip->frame)){
		return TRUE;
	}
	SRL_strength.UD[0] = fp->track[0];			// x

	TSmooth[fp->track[1]](fp, fpip);
	return TRUE;
}
//---------------------------------------------------------------------
//		tB^I
//---------------------------------------------------------------------
static BOOL func_exit(FILTER *fp) {
	return TRUE;
}
